Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.70.2.2
retrieving revision 1.70.2.3
diff -u -r1.70.2.2 -r1.70.2.3
--- squid/src/client_side.c	3 Sep 2002 10:29:38 -0000	1.70.2.2
+++ squid/src/client_side.c	5 Sep 2002 10:28:20 -0000	1.70.2.3
@@ -1868,243 +586,11 @@
 	    http->reqbuf,
 	    clientSendMoreData,
 	    http);
+	break;
+      default:fatal ("Hit unreachable code in clientWriteComplete\n");
     }
 }
 
-/*
- * client issued a request with an only-if-cached cache-control directive;
- * we did not find a cached object that can be returned without
- *     contacting other servers;
- * respond with a 504 (Gateway Timeout) as suggested in [RFC 2068]
- */
-static void
-clientProcessOnlyIfCachedMiss(clientHttpRequest * http)
-{
-    char *url = http->uri;
-    request_t *r = http->request;
-    ErrorState *err = NULL;
-    debug(33, 4) ("clientProcessOnlyIfCachedMiss: '%s %s'\n",
-	RequestMethodStr[r->method], url);
-    http->al.http.code = HTTP_GATEWAY_TIMEOUT;
-    err = errorCon(ERR_ONLY_IF_CACHED_MISS, HTTP_GATEWAY_TIMEOUT);
-    err->request = requestLink(r);
-    err->src_addr = http->conn->peer.sin_addr;
-    if (http->entry) {
-	storeUnregister(http->sc, http->entry, http);
-	http->sc = NULL;
-	storeUnlockObject(http->entry);
-    }
-    http->entry = clientCreateStoreEntry(http, r->method, null_request_flags);
-    errorAppendEntry(http->entry, err);
-}
-
-static log_type
-clientProcessRequest2(clientHttpRequest * http)
-{
-    request_t *r = http->request;
-    StoreEntry *e;
-    if (r->flags.cachable || r->flags.internal)
-	e = http->entry = storeGetPublicByRequest(r);
-    else
-	e = http->entry = NULL;
-    /* Release negatively cached IP-cache entries on reload */
-    if (r->flags.nocache)
-	ipcacheInvalidate(r->host);
-#if HTTP_VIOLATIONS
-    else if (r->flags.nocache_hack)
-	ipcacheInvalidate(r->host);
-#endif
-#if USE_CACHE_DIGESTS
-    http->lookup_type = e ? "HIT" : "MISS";
-#endif
-    if (NULL == e) {
-	/* this object isn't in the cache */
-	debug(33, 3) ("clientProcessRequest2: storeGet() MISS\n");
-	return LOG_TCP_MISS;
-    }
-    if (Config.onoff.offline) {
-	debug(33, 3) ("clientProcessRequest2: offline HIT\n");
-	http->entry = e;
-	return LOG_TCP_HIT;
-    }
-    if (http->redirect.status) {
-	/* force this to be a miss */
-	http->entry = NULL;
-	return LOG_TCP_MISS;
-    }
-    if (!storeEntryValidToSend(e)) {
-	debug(33, 3) ("clientProcessRequest2: !storeEntryValidToSend MISS\n");
-	http->entry = NULL;
-	return LOG_TCP_MISS;
-    }
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-	/* Special entries are always hits, no matter what the client says */
-	debug(33, 3) ("clientProcessRequest2: ENTRY_SPECIAL HIT\n");
-	http->entry = e;
-	return LOG_TCP_HIT;
-    }
-#if HTTP_VIOLATIONS
-    if (e->store_status == STORE_PENDING) {
-	if (r->flags.nocache || r->flags.nocache_hack) {
-	    debug(33, 3) ("Clearing no-cache for STORE_PENDING request\n\t%s\n",
-		storeUrl(e));
-	    r->flags.nocache = 0;
-	    r->flags.nocache_hack = 0;
-	}
-    }
-#endif
-    if (r->flags.nocache) {
-	debug(33, 3) ("clientProcessRequest2: no-cache REFRESH MISS\n");
-	http->entry = NULL;
-	return LOG_TCP_CLIENT_REFRESH_MISS;
-    }
-    /* We don't cache any range requests (for now!) -- adrian */
-    if (r->flags.range) {
-	http->entry = NULL;
-	return LOG_TCP_MISS;
-    }
-    debug(33, 3) ("clientProcessRequest2: default HIT\n");
-    http->entry = e;
-    return LOG_TCP_HIT;
-}
-
-static void
-clientProcessRequest(clientHttpRequest * http)
-{
-    char *url = http->uri;
-    request_t *r = http->request;
-    HttpReply *rep;
-    http_version_t version;
-    debug(33, 4) ("clientProcessRequest: %s '%s'\n",
-	RequestMethodStr[r->method],
-	url);
-    if (r->method == METHOD_CONNECT) {
-	http->log_type = LOG_TCP_MISS;
-	sslStart(http, &http->out.size, &http->al.http.code);
-	return;
-    } else if (r->method == METHOD_PURGE) {
-	clientPurgeRequest(http);
-	return;
-    } else if (r->method == METHOD_TRACE) {
-	if (r->max_forwards == 0) {
-	    http->entry = clientCreateStoreEntry(http, r->method, null_request_flags);
-	    storeReleaseRequest(http->entry);
-	    storeBuffer(http->entry);
-	    rep = httpReplyCreate();
-	    httpBuildVersion(&version, 1, 0);
-	    httpReplySetHeaders(rep, version, HTTP_OK, NULL, "text/plain",
-		httpRequestPrefixLen(r), 0, squid_curtime);
-	    httpReplySwapOut(rep, http->entry);
-	    httpReplyDestroy(rep);
-	    httpRequestSwapOut(r, http->entry);
-	    storeComplete(http->entry);
-	    return;
-	}
-	/* yes, continue */
-	http->log_type = LOG_TCP_MISS;
-    } else {
-	http->log_type = clientProcessRequest2(http);
-    }
-    debug(33, 4) ("clientProcessRequest: %s for '%s'\n",
-	log_tags[http->log_type],
-	http->uri);
-    http->out.offset = 0;
-    if (NULL != http->entry) {
-	storeLockObject(http->entry);
-	if (NULL == http->entry->mem_obj) {
-	    /*
-	     * This if-block exists because we don't want to clobber
-	     * a preexiting mem_obj->method value if the mem_obj
-	     * already exists.  For example, when a HEAD request
-	     * is a cache hit for a GET response, we want to keep
-	     * the method as GET.
-	     */
-	    storeCreateMemObject(http->entry, http->uri, http->log_uri);
-	    http->entry->mem_obj->method = r->method;
-	}
-	http->sc = storeClientListAdd(http->entry, http);
-#if DELAY_POOLS
-	delaySetStoreClient(http->sc, delayClient(http));
-#endif
-	assert(http->log_type == LOG_TCP_HIT);
-	http->reqofs = 0;
-	storeClientCopy(http->sc, http->entry,
-	    http->out.offset,
-	    HTTP_REQBUF_SZ,
-	    http->reqbuf,
-	    clientCacheHit,
-	    http);
-    } else {
-	/* MISS CASE, http->log_type is already set! */
-	clientProcessMiss(http);
-    }
-}
-
-/*
- * Prepare to fetch the object as it's a cache miss of some kind.
- */
-static void
-clientProcessMiss(clientHttpRequest * http)
-{
-    char *url = http->uri;
-    request_t *r = http->request;
-    ErrorState *err = NULL;
-    debug(33, 4) ("clientProcessMiss: '%s %s'\n",
-	RequestMethodStr[r->method], url);
-    /*
-     * We might have a left-over StoreEntry from a failed cache hit
-     * or IMS request.
-     */
-    if (http->entry) {
-	if (EBIT_TEST(http->entry->flags, ENTRY_SPECIAL)) {
-	    debug(33, 0) ("clientProcessMiss: miss on a special object (%s).\n", url);
-	    debug(33, 0) ("\tlog_type = %s\n", log_tags[http->log_type]);
-	    storeEntryDump(http->entry, 1);
-	}
-	storeUnregister(http->sc, http->entry, http);
-	http->sc = NULL;
-	storeUnlockObject(http->entry);
-	http->entry = NULL;
-    }
-    if (r->method == METHOD_PURGE) {
-	clientPurgeRequest(http);
-	return;
-    }
-    if (clientOnlyIfCached(http)) {
-	clientProcessOnlyIfCachedMiss(http);
-	return;
-    }
-    /*
-     * Deny loops when running in accelerator/transproxy mode.
-     */
-    if (http->flags.accel && r->flags.loopdetect) {
-	http->al.http.code = HTTP_FORBIDDEN;
-	err = errorCon(ERR_ACCESS_DENIED, HTTP_FORBIDDEN);
-	err->request = requestLink(r);
-	err->src_addr = http->conn->peer.sin_addr;
-	http->entry = clientCreateStoreEntry(http, r->method, null_request_flags);
-	errorAppendEntry(http->entry, err);
-	return;
-    }
-    assert(http->out.offset == 0);
-    http->entry = clientCreateStoreEntry(http, r->method, r->flags);
-    if (http->redirect.status) {
-	HttpReply *rep = httpReplyCreate();
-#if LOG_TCP_REDIRECTS
-	http->log_type = LOG_TCP_REDIRECT;
-#endif
-	storeReleaseRequest(http->entry);
-	httpRedirectReply(rep, http->redirect.status, http->redirect.location);
-	httpReplySwapOut(rep, http->entry);
-	httpReplyDestroy(rep);
-	storeComplete(http->entry);
-	return;
-    }
-    if (http->flags.internal)
-	r->protocol = PROTO_INTERNAL;
-    fwdStart(http->conn->fd, http->entry, r);
-}
-
 static clientHttpRequest *
 parseHttpRequestAbort(ConnStateData * conn, const char *uri)
 {
@@ -2116,10 +602,78 @@
     http->uri = xstrdup(uri);
     http->log_uri = xstrndup(uri, MAX_URL);
     http->reqbuf = http->norm_reqbuf;
+    /* default socket stream terminator */
+    http->stream_head = NULL;
+    clientStreamInsertHead (&http->stream_head, clientSocketRecipient, NULL);
     dlinkAdd(http, &http->active, &ClientActiveRequests);
     return http;
 }
 
+/* Utility function to perform part of request parsing */
+static clientHttpRequest *
+clientParseHttpRequestLine (char *inbuf, size_t req_sz, ConnStateData * conn, method_t *method_p, char **url_p, http_version_t *http_ver_p)
+{
+    char *mstr = NULL;
+    char *url = NULL;
+    char *token = NULL;
+    char *t;
+    /* Barf on NULL characters in the headers */
+    if (strlen(inbuf) != req_sz) {
+	debug(33, 1) ("parseHttpRequest: Requestheader contains NULL characters\n");
+	return parseHttpRequestAbort(conn, "error:invalid-request");
+    }
+
+    /* Look for request method */
+    if ((mstr = strtok(inbuf, "\t ")) == NULL) {
+	debug(33, 1) ("parseHttpRequest: Can't get request method\n");
+	return parseHttpRequestAbort(conn, "error:invalid-request-method");
+    }
+    *method_p = urlParseMethod(mstr);
+    if (*method_p == METHOD_NONE) {
+	debug(33, 1) ("parseHttpRequest: Unsupported method '%s'\n", mstr);
+	return parseHttpRequestAbort(conn, "error:unsupported-request-method");
+    }
+    debug(33, 5) ("parseHttpRequest: Method is '%s'\n", mstr);
+
+    /* look for URL+HTTP/x.x */
+    if ((url = strtok(NULL, "\n")) == NULL) {
+        debug(33, 1) ("parseHttpRequest: Missing URL\n");
+        return parseHttpRequestAbort(conn, "error:missing-url");
+    }
+    while (xisspace(*url))
+        url++;
+    t = url + strlen(url);
+    assert(*t == '\0');
+    while (t > url) {
+        t--;
+        if (xisspace(*t) && !strncmp(t + 1, "HTTP/", 5)) {
+            token = t + 1;
+            break;
+        }
+    }
+    while (t > url && xisspace(*t))
+        *(t--) = '\0';
+    debug(33, 5) ("parseHttpRequest: URI is '%s'\n", url);
+    *url_p = url;
+    if (token == NULL) {
+        debug(33, 3) ("parseHttpRequest: Missing HTTP identifier\n");
+#if RELAXED_HTTP_PARSER
+        httpBuildVersion(http_ver_p, 0, 9);      /* wild guess */
+#else
+        return parseHttpRequestAbort(conn, "error:missing-http-ident");
+#endif
+    } else {
+        if (sscanf(token + 5, "%d.%d", &http_ver_p->major, &http_ver_p->minor) != 2) {
+            debug(33, 3) ("parseHttpRequest: Invalid HTTP identifier.\n");
+            return parseHttpRequestAbort(conn, "error: invalid HTTP-ident");
+        }
+        debug(33, 6) ("parseHttpRequest: Client HTTP version %d.%d.\n", http_ver_p->major, http_ver_p->minor);
+    }
+
+    /* everything was ok */
+    return NULL;
+}
+
 /*
  *  parseHttpRequest()
  * 
@@ -2132,19 +686,16 @@
     char **prefix_p, size_t * req_line_sz_p)
 {
     char *inbuf = NULL;
-    char *mstr = NULL;
     char *url = NULL;
     char *req_hdr = NULL;
     http_version_t http_ver;
-    char *token = NULL;
     char *t = NULL;
     char *end;
     size_t header_sz;		/* size of headers, not including first line */
     size_t prefix_sz;		/* size of whole request (req-line + headers) */
     size_t url_sz;
     size_t req_sz;
-    method_t method;
-    clientHttpRequest *http = NULL;
+    clientHttpRequest *http;
 #if IPF_TRANSPARENT
     struct natlookup natLookup;
     static int natfd = -1;
@@ -2175,63 +726,11 @@
     xmemcpy(inbuf, conn->in.buf, req_sz);
     *(inbuf + req_sz) = '\0';
 
-    /* Barf on NULL characters in the headers */
-    if (strlen(inbuf) != req_sz) {
-	debug(33, 1) ("parseHttpRequest: Requestheader contains NULL characters\n");
-	xfree(inbuf);
-	return parseHttpRequestAbort(conn, "error:invalid-request");
-    }
-    /* Look for request method */
-    if ((mstr = strtok(inbuf, "\t ")) == NULL) {
-	debug(33, 1) ("parseHttpRequest: Can't get request method\n");
-	xfree(inbuf);
-	return parseHttpRequestAbort(conn, "error:invalid-request-method");
-    }
-    method = urlParseMethod(mstr);
-    if (method == METHOD_NONE) {
-	debug(33, 1) ("parseHttpRequest: Unsupported method '%s'\n", mstr);
-	xfree(inbuf);
-	return parseHttpRequestAbort(conn, "error:unsupported-request-method");
-    }
-    debug(33, 5) ("parseHttpRequest: Method is '%s'\n", mstr);
-    *method_p = method;
-
-    /* look for URL+HTTP/x.x */
-    if ((url = strtok(NULL, "\n")) == NULL) {
-	debug(33, 1) ("parseHttpRequest: Missing URL\n");
-	xfree(inbuf);
-	return parseHttpRequestAbort(conn, "error:missing-url");
-    }
-    while (xisspace(*url))
-	url++;
-    t = url + strlen(url);
-    assert(*t == '\0');
-    token = NULL;
-    while (t > url) {
-	t--;
-	if (xisspace(*t) && !strncmp(t + 1, "HTTP/", 5)) {
-	    token = t + 1;
-	    break;
-	}
-    }
-    while (t > url && xisspace(*t))
-	*(t--) = '\0';
-    debug(33, 5) ("parseHttpRequest: URI is '%s'\n", url);
-    if (token == NULL) {
-	debug(33, 3) ("parseHttpRequest: Missing HTTP identifier\n");
-#if RELAXED_HTTP_PARSER
-	httpBuildVersion(&http_ver, 0, 9);	/* wild guess */
-#else
+    /* Is there a legitimate first line to the headers ? */
+    if ((http = clientParseHttpRequestLine (inbuf, req_sz, conn, method_p, &url, &http_ver))) {
+	/* something wrong, abort */
 	xfree(inbuf);
-	return parseHttpRequestAbort(conn, "error:missing-http-ident");
-#endif
-    } else {
-	if (sscanf(token + 5, "%d.%d", &http_ver.major, &http_ver.minor) != 2) {
-	    debug(33, 3) ("parseHttpRequest: Invalid HTTP identifier.\n");
-	    xfree(inbuf);
-	    return parseHttpRequestAbort(conn, "error: invalid HTTP-ident");
-	}
-	debug(33, 6) ("parseHttpRequest: Client HTTP version %d.%d.\n", http_ver.major, http_ver.minor);
+	return http;
     }
 
     /*
@@ -2263,11 +762,16 @@
     http->start = current_time;
     http->req_sz = prefix_sz;
     http->reqbuf = http->norm_reqbuf;
+    /* default socket based stream terminator */
+    http->stream_head = NULL;
+    clientStreamInsertHead (&http->stream_head, clientSocketRecipient, NULL);
     *prefix_p = xmalloc(prefix_sz + 1);
     xmemcpy(*prefix_p, conn->in.buf, prefix_sz);
     *(*prefix_p + prefix_sz) = '\0';
     dlinkAdd(http, &http->active, &ClientActiveRequests);
 
+    /* XXX this function is still way to long. here is a natural point for further simplification */
+    
     debug(33, 5) ("parseHttpRequest: Request Header is\n%s\n", (*prefix_p) + *req_line_sz_p);
 #if THIS_VIOLATES_HTTP_SPECS_ON_URL_TRANSFORMATION
     if ((t = strchr(url, '#')))	/* remove HTML anchors */
@@ -2587,7 +1091,8 @@
 	    commSetTimeout(fd, Config.Timeout.lifetime, clientLifetimeTimeout, http);
 	    if (parser_return_code < 0) {
 		debug(33, 1) ("clientReadRequest: FD %d Invalid Request\n", fd);
-		err = errorCon(ERR_INVALID_REQ, HTTP_BAD_REQUEST);
+		err = clientBuildError(ERR_INVALID_REQ, HTTP_BAD_REQUEST, NULL, &conn->peer.sin_addr,
+				       NULL);
 		err->request_hdrs = xstrdup(conn->in.buf);
 		http->entry = clientCreateStoreEntry(http, method, null_request_flags);
 		errorAppendEntry(http->entry, err);
@@ -2596,9 +1101,8 @@
 	    }
 	    if ((request = urlParse(method, http->uri)) == NULL) {
 		debug(33, 5) ("Invalid URL: %s\n", http->uri);
-		err = errorCon(ERR_INVALID_URL, HTTP_BAD_REQUEST);
-		err->src_addr = conn->peer.sin_addr;
-		err->url = xstrdup(http->uri);
+		err = clientBuildError(ERR_INVALID_URL, HTTP_BAD_REQUEST, http->uri,
+				       &conn->peer.sin_addr, NULL);
 		http->al.http.code = err->http_status;
 		http->entry = clientCreateStoreEntry(http, method, null_request_flags);
 		errorAppendEntry(http->entry, err);
@@ -2640,9 +1144,8 @@
 	    request->http_ver = http->http_ver;
 	    if (!urlCheckRequest(request) ||
 		httpHeaderHas(&request->header, HDR_TRANSFER_ENCODING)) {
-		err = errorCon(ERR_UNSUP_REQ, HTTP_NOT_IMPLEMENTED);
-		err->src_addr = conn->peer.sin_addr;
-		err->request = requestLink(request);
+		err = clientBuildError(ERR_UNSUP_REQ, HTTP_NOT_IMPLEMENTED, NULL, &conn->peer.sin_addr,
+				       request);
 		request->flags.proxy_keepalive = 0;
 		http->al.http.code = err->http_status;
 		http->entry = clientCreateStoreEntry(http, request->method, null_request_flags);
@@ -2650,9 +1153,8 @@
 		break;
 	    }
 	    if (!clientCheckContentLength(request)) {
-		err = errorCon(ERR_INVALID_REQ, HTTP_LENGTH_REQUIRED);
-		err->src_addr = conn->peer.sin_addr;
-		err->request = requestLink(request);
+		err = clientBuildError(ERR_INVALID_REQ, HTTP_LENGTH_REQUIRED, NULL,
+				       &conn->peer.sin_addr, request);
 		http->al.http.code = err->http_status;
 		http->entry = clientCreateStoreEntry(http, request->method, null_request_flags);
 		errorAppendEntry(http->entry, err);
@@ -2666,8 +1168,8 @@
 		request->body_connection = conn;
 		/* Is it too large? */
 		if (clientRequestBodyTooLarge(request->content_length)) {
-		    err = errorCon(ERR_TOO_BIG, HTTP_REQUEST_ENTITY_TOO_LARGE);
-		    err->request = requestLink(request);
+		    err = clientBuildError(ERR_TOO_BIG, HTTP_REQUEST_ENTITY_TOO_LARGE, NULL, 
+				   &conn->peer.sin_addr, http->request);
 		    http->entry = clientCreateStoreEntry(http,
 			METHOD_NONE, null_request_flags);
 		    errorAppendEntry(http->entry, err);
@@ -2687,7 +1189,8 @@
 		    (int) conn->in.offset);
 		debug(33, 1) ("Config 'request_header_max_size'= %ld bytes.\n",
 		    (long int) Config.maxRequestHeaderSize);
-		err = errorCon(ERR_TOO_BIG, HTTP_REQUEST_ENTITY_TOO_LARGE);
+		err = clientBuildError(ERR_TOO_BIG, HTTP_REQUEST_ENTITY_TOO_LARGE, NULL,
+				       &conn->peer.sin_addr, NULL);
 		http = parseHttpRequestAbort(conn, "error:request-too-large");
 		/* add to the client request queue */
 		for (H = &conn->chr; *H; H = &(*H)->next);
@@ -2844,8 +1347,7 @@
 	/*
 	 * Generate an error
 	 */
-	err = errorCon(ERR_LIFETIME_EXP, HTTP_REQUEST_TIMEOUT);
-	err->url = xstrdup("N/A");
+	err = clientBuildError(ERR_LIFETIME_EXP, HTTP_REQUEST_TIMEOUT, "N/A", &conn->peer.sin_addr, NULL);
 	/*
 	 * Normally we shouldn't call errorSend() in client_side.c, but
 	 * it should be okay in this case.  Presumably if we get here
@@ -3066,86 +1568,6 @@
 
 #endif /* USE_SSL */
 
-#define SENDING_BODY 0
-#define SENDING_HDRSONLY 1
-static int
-clientCheckTransferDone(clientHttpRequest * http)
-{
-    int sending = SENDING_BODY;
-    StoreEntry *entry = http->entry;
-    MemObject *mem;
-    http_reply *reply;
-    int sendlen;
-    if (entry == NULL)
-	return 0;
-    /*
-     * For now, 'done_copying' is used for special cases like
-     * Range and HEAD requests.
-     */
-    if (http->flags.done_copying)
-	return 1;
-    /*
-     * Handle STORE_OK objects.
-     * objectLen(entry) will be set proprely.
-     */
-    if (entry->store_status == STORE_OK) {
-	if (http->out.offset >= objectLen(entry))
-	    return 1;
-	else
-	    return 0;
-    }
-    /*
-     * Now, handle STORE_PENDING objects
-     */
-    mem = entry->mem_obj;
-    assert(mem != NULL);
-    assert(http->request != NULL);
-    reply = mem->reply;
-    if (reply->hdr_sz == 0)
-	return 0;		/* haven't found end of headers yet */
-    else if (reply->sline.status == HTTP_OK)
-	sending = SENDING_BODY;
-    else if (reply->sline.status == HTTP_NO_CONTENT)
-	sending = SENDING_HDRSONLY;
-    else if (reply->sline.status == HTTP_NOT_MODIFIED)
-	sending = SENDING_HDRSONLY;
-    else if (reply->sline.status < HTTP_OK)
-	sending = SENDING_HDRSONLY;
-    else if (http->request->method == METHOD_HEAD)
-	sending = SENDING_HDRSONLY;
-    else
-	sending = SENDING_BODY;
-    /*
-     * Figure out how much data we are supposed to send.
-     * If we are sending a body and we don't have a content-length,
-     * then we must wait for the object to become STORE_OK.
-     */
-    if (sending == SENDING_HDRSONLY)
-	sendlen = reply->hdr_sz;
-    else if (reply->content_length < 0)
-	return 0;
-    else
-	sendlen = reply->content_length + reply->hdr_sz;
-    /*
-     * Now that we have the expected length, did we send it all?
-     */
-    if (http->out.offset < sendlen)
-	return 0;
-    else
-	return 1;
-}
-
-static int
-clientGotNotEnough(clientHttpRequest * http)
-{
-    int cl = httpReplyBodySize(http->request->method, http->entry->mem_obj->reply);
-    int hs = http->entry->mem_obj->reply->hdr_sz;
-    assert(cl >= 0);
-    if (http->out.offset < cl + hs)
-	return 1;
-    return 0;
-}
-
 /*
  * This function is designed to serve a fairly specific purpose.
  * Occasionally our vBNS-connected caches can talk to each other, but not
Index: squid/src/errorpage.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/errorpage.c,v
retrieving revision 1.21
retrieving revision 1.21.6.1
diff -u -r1.21 -r1.21.6.1
--- squid/src/errorpage.c	19 Jul 2002 00:01:05 -0000	1.21
+++ squid/src/errorpage.c	5 Sep 2002 10:28:20 -0000	1.21.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: errorpage.c,v 1.21 2002/07/19 00:01:05 squidadm Exp $
+ * $Id: errorpage.c,v 1.21.6.1 2002/09/05 10:28:20 rbcollins Exp $
  *
  * DEBUG: section 4     Error Generation
  * AUTHOR: Duane Wessels
@@ -41,7 +41,8 @@
  */
 
 #include "squid.h"
-
+#include "HttpReply.h"
+#include "HttpRequest.h"
 
 /* local types */
 
@@ -315,7 +316,6 @@
      */
     authenticateFixHeader(rep, err->auth_user_request, err->request, 0, 1);
     httpReplySwapOut(rep, entry);
-    httpReplyAbsorb(mem->reply, rep);
     EBIT_CLR(entry->flags, ENTRY_FWD_HDR_WAIT);
     storeBufferFlush(entry);
     storeComplete(entry);
Index: squid/src/forward.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/forward.c,v
retrieving revision 1.16
retrieving revision 1.16.6.1
diff -u -r1.16 -r1.16.6.1
--- squid/src/forward.c	21 Jun 2002 13:00:28 -0000	1.16
+++ squid/src/forward.c	5 Sep 2002 10:28:20 -0000	1.16.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: forward.c,v 1.16 2002/06/21 13:00:28 squidadm Exp $
+ * $Id: forward.c,v 1.16.6.1 2002/09/05 10:28:20 rbcollins Exp $
  *
  * DEBUG: section 17    Request Forwarding
  * AUTHOR: Duane Wessels
@@ -35,6 +35,7 @@
 
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 static PSC fwdStartComplete;
 static void fwdDispatch(FwdState *);
@@ -339,6 +340,7 @@
 	ctimeout = fs->peer->connect_timeout > 0 ? fs->peer->connect_timeout
 	    : Config.Timeout.peer_connect;
     } else if (fwdState->request->flags.accelerated &&
+	!fwdState->request->flags.internalclient &&
 	Config.Accel.single_host && Config.Accel.host) {
 	host = Config.Accel.host;
 	port = Config.Accel.port;
Index: squid/src/ftp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ftp.c,v
retrieving revision 1.26
retrieving revision 1.26.2.1
diff -u -r1.26 -r1.26.2.1
--- squid/src/ftp.c	27 Aug 2002 21:46:11 -0000	1.26
+++ squid/src/ftp.c	5 Sep 2002 10:28:20 -0000	1.26.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ftp.c,v 1.26 2002/08/27 21:46:11 squidadm Exp $
+ * $Id: ftp.c,v 1.26.2.1 2002/09/05 10:28:20 rbcollins Exp $
  *
  * DEBUG: section 9     File Transfer Protocol (FTP)
  * AUTHOR: Harvest Derived
@@ -34,6 +34,8 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
+#include "HttpReply.h"
 
 static const char *const crlf = "\r\n";
 static char cbuf[1024];
@@ -1088,7 +1090,7 @@
 		ftpState->user, request->port);
 	}
 	/* create reply */
-	reply = entry->mem_obj->reply;
+	reply = httpReplyCreate ();
 	assert(reply != NULL);
 	/* create appropriate reply */
 	ftpAuthRequired(reply, request, realm);
@@ -2505,7 +2507,7 @@
     const char *filename = NULL;
     const char *t = NULL;
     StoreEntry *e = ftpState->entry;
-    http_reply *reply = e->mem_obj->reply;
+    http_reply *reply;
     http_version_t version;
 
     if (ftpState->flags.http_header_sent)
@@ -2532,7 +2534,7 @@
 	}
     }
     storeBuffer(e);
-    httpReplyReset(reply);
+    reply = httpReplyCreate();
     /* set standard stuff */
     if (ftpState->restarted_offset) {
 	/* Partial reply */
@@ -2554,7 +2556,9 @@
 	httpHeaderPutStr(&reply->header, HDR_CONTENT_ENCODING, mime_enc);
     httpReplySwapOut(reply, e);
     storeBufferFlush(e);
+#if BROKENCODE
     reply->hdr_sz = e->mem_obj->inmem_hi;
+#endif
     storeTimestampsSet(e);
     if (ftpState->flags.authenticated) {
 	/*
Index: squid/src/gopher.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/gopher.c,v
retrieving revision 1.17.2.1
retrieving revision 1.17.2.2
diff -u -r1.17.2.1 -r1.17.2.2
--- squid/src/gopher.c	3 Sep 2002 08:31:33 -0000	1.17.2.1
+++ squid/src/gopher.c	5 Sep 2002 10:28:20 -0000	1.17.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: gopher.c,v 1.17.2.1 2002/09/03 08:31:33 rbcollins Exp $
+ * $Id: gopher.c,v 1.17.2.2 2002/09/05 10:28:20 rbcollins Exp $
  *
  * DEBUG: section 10    Gopher
  * AUTHOR: Harvest Derived
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 /* gopher type code from rfc. Anawat. */
 #define GOPHER_FILE         '0'
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.21.6.2
retrieving revision 1.21.6.3
diff -u -r1.21.6.2 -r1.21.6.3
--- squid/src/http.c	3 Sep 2002 08:31:34 -0000	1.21.6.2
+++ squid/src/http.c	5 Sep 2002 10:28:21 -0000	1.21.6.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.21.6.2 2002/09/03 08:31:34 rbcollins Exp $
+ * $Id: http.c,v 1.21.6.3 2002/09/05 10:28:21 rbcollins Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -39,6 +39,8 @@
  */
 
 #include "squid.h"
+#include "HttpReply.h"
+#include "HttpRequest.h"
 #include "HttpStrategy.h"
 
 static const char *const crlf = "\r\n";
@@ -217,8 +219,8 @@
 static int
 httpCachableReply(HttpStateData * httpState)
 {
-    HttpReply *rep = httpState->entry->mem_obj->reply;
-    HttpHeader *hdr = &rep->header;
+    HttpReply const *rep = httpState->entry->mem_obj->reply;
+    HttpHeader const *hdr = &rep->header;
     const int cc_mask = (rep->cache_control) ? rep->cache_control->mask : 0;
     const char *v;
     if (EBIT_TEST(cc_mask, CC_PRIVATE))
@@ -326,7 +328,7 @@
  * Returns false if the variance cannot be stored
  */
 const char *
-httpMakeVaryMark(request_t * request, HttpReply * reply)
+httpMakeVaryMark(request_t * request, HttpReply const * reply)
 {
     String vary, hdr;
     const char *pos = NULL;
@@ -387,7 +389,9 @@
     StoreEntry *entry = httpState->entry;
     int room;
     size_t hdr_len;
-    HttpReply *reply = entry->mem_obj->reply;
+    /* Creates a blank header. If this routine is made incremental, this will
+     * not do */
+    HttpReply *reply = httpReplyCreate();
     Ctx ctx;
     debug(11, 3) ("httpProcessReplyHeader: key '%s'\n",
 	storeKeyText(entry->hash.key));
@@ -404,6 +408,7 @@
 	debug(11, 3) ("httpProcessReplyHeader: Non-HTTP-compliant header: '%s'\n", httpState->reply_hdr);
 	httpState->reply_hdr_state += 2;
 	reply->sline.status = HTTP_INVALID_HEADER;
+	storeEntryReplaceObject (entry, reply);
 	return;
     }
     t = httpState->reply_hdr + hdr_len;
@@ -480,6 +485,10 @@
 #if HEADERS_LOG
     headersLog(1, 0, httpState->request->method, reply);
 #endif
+    /* TODO: we need our own reply * in the httpState, as we probably don't want to replace 
+     * the storeEntry with interim headers
+     */
+    storeEntryReplaceObject (entry, reply);
 }
 
 static int
@@ -487,7 +496,7 @@
 {
     /* return 1 if we got the last of the data on a persistent connection */
     MemObject *mem = httpState->entry->mem_obj;
-    HttpReply *reply = mem->reply;
+    HttpReply const *reply = mem->reply;
     int clen;
     debug(11, 3) ("httpPconnTransferDone: FD %d\n", httpState->fd);
     /*
@@ -640,7 +649,8 @@
 		    EBIT_CLR(entry->flags, ENTRY_FWD_HDR_WAIT);
 	    }
 	}
-	storeAppend(entry, buf, len);
+	if (len > entry->mem_obj->reply->hdr_sz)
+	    storeAppend(entry, buf+entry->mem_obj->reply->hdr_sz, len - entry->mem_obj->reply->hdr_sz);
 	if (EBIT_TEST(entry->flags, ENTRY_ABORTED)) {
 	    /*
 	     * the above storeAppend() call could ABORT this entry,
Index: squid/src/icp_v2.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icp_v2.c,v
retrieving revision 1.6
retrieving revision 1.6.2.1
diff -u -r1.6 -r1.6.2.1
--- squid/src/icp_v2.c	9 Aug 2002 21:46:02 -0000	1.6
+++ squid/src/icp_v2.c	5 Sep 2002 10:28:21 -0000	1.6.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icp_v2.c,v 1.6 2002/08/09 21:46:02 squidadm Exp $
+ * $Id: icp_v2.c,v 1.6.2.1 2002/09/05 10:28:21 rbcollins Exp $
  *
  * DEBUG: section 12    Internet Cache Protocol
  * AUTHOR: Duane Wessels
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 static void icpLogIcp(struct in_addr, log_type, int, const char *, int);
 static void icpHandleIcpV2(int, struct sockaddr_in, char *, int);
Index: squid/src/icp_v3.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icp_v3.c,v
retrieving revision 1.5
retrieving revision 1.5.2.1
diff -u -r1.5 -r1.5.2.1
--- squid/src/icp_v3.c	9 Aug 2002 21:46:02 -0000	1.5
+++ squid/src/icp_v3.c	5 Sep 2002 10:28:21 -0000	1.5.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icp_v3.c,v 1.5 2002/08/09 21:46:02 squidadm Exp $
+ * $Id: icp_v3.c,v 1.5.2.1 2002/09/05 10:28:21 rbcollins Exp $
  *
  * DEBUG: section 12    Internet Cache Protocol
  * AUTHOR: Duane Wessels
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
 
 /* Currently Harvest cached-2.x uses ICP_VERSION_3 */
 void
Index: squid/src/internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/internal.c,v
retrieving revision 1.9
retrieving revision 1.9.10.1
diff -u -r1.9 -r1.9.10.1
--- squid/src/internal.c	11 Apr 2002 22:30:30 -0000	1.9
+++ squid/src/internal.c	5 Sep 2002 10:28:21 -0000	1.9.10.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: internal.c,v 1.9 2002/04/11 22:30:30 squidadm Exp $
+ * $Id: internal.c,v 1.9.10.1 2002/09/05 10:28:21 rbcollins Exp $
  *
  * DEBUG: section 76    Internal Squid Object handling
  * AUTHOR: Duane, Alex, Henrik
@@ -34,6 +34,8 @@
  */
 
 #include "squid.h"
+#include "HttpRequest.h"
+#include "HttpReply.h"
 
 /* called when we "miss" on an internal object;
  * generate known dynamic objects, 
@@ -50,13 +52,15 @@
     if (0 == strcmp(upath, "/squid-internal-dynamic/netdb")) {
 	netdbBinaryExchange(entry);
     } else if (0 == strcmp(upath, "/squid-internal-periodic/store_digest")) {
+	HttpReply *reply;
 #if USE_CACHE_DIGESTS
 	const char *msgbuf = "This cache is currently building its digest.\n";
 #else
 	const char *msgbuf = "This cache does not suport Cache Digests.\n";
 #endif
 	httpBuildVersion(&version, 1, 0);
-	httpReplySetHeaders(entry->mem_obj->reply,
+	reply = httpReplyCreate();
+	httpReplySetHeaders(reply,
 	    version,
 	    HTTP_NOT_FOUND,
 	    "Not Found",
@@ -64,7 +68,7 @@
 	    strlen(msgbuf),
 	    squid_curtime,
 	    -2);
-	httpReplySwapOut(entry->mem_obj->reply, entry);
+	httpReplySwapOut(reply, entry);
 	storeAppend(entry, msgbuf, strlen(msgbuf));
 	storeComplete(entry);
     } else {
Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.36
retrieving revision 1.36.2.1
diff -u -r1.36 -r1.36.2.1
--- squid/src/main.c	8 Aug 2002 19:41:58 -0000	1.36
+++ squid/src/main.c	5 Sep 2002 10:28:21 -0000	1.36.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.36 2002/08/08 19:41:58 squidadm Exp $
+ * $Id: main.c,v 1.36.2.1 2002/09/05 10:28:21 rbcollins Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -34,6 +34,7 @@
  */
 
 #include "squid.h"
+#include "HttpReply.h"
 
 /* for error reporting from xmalloc and friends */
 extern void (*failure_notify) (const char *);
